//
// Exemple d'application utilisant la classe BTree:
// fichier d'entier organise en B-Arbre
//

#include <iostream.h>	// pour les E/S sur la console (cin, cout, ...)
#include "btree.h"	// pour BTree, TNoeud, TVal, ...


int main()
{
   char nom[80], mode[20];
   cout << "Donner un nom de fichier pour le B-Arbre : ";
   cin >> nom;
   cout << "'N'ouveau ou 'A'ncien fichier ? (n/a) : ";
   cin >> mode;
   
   if (mode[0] == 'n' || mode[0] == 'N') 
     	mode[0] = 'N';
   else 
   	mode[0] = 'A';
   
   // L'ouverture du fichier se fait au niveau du constructeur:
   BTree bt(nom,mode[0]); 
   
   int i,stop=0;
   TVal v;		// l'article se resume a sa cle (un entier)
   TNoeud buf;		// buf : un noeud du B-Arbre
   do {
      	cout << "\n\n";
	cout << "1) Inserer une valeur\n";
	cout << "2) Affichage d'un noeud\n";
	cout << "3) Parcours inordre\n";
	cout << "4) Supprimer une valeur\n";
	cout << "5) Voir Entete\n";
	cout << "0) Quitter\n\n\tChoix : ";
	cin >> i;	// lire i
	cout << "\n";
	switch(i) {
	   case 1 :	// Insertion d'un entier dans le B-Arbre bt
			cout << "Donner une valeur a inserer : ";
			cin >> v;	// lire v
			bt.Ins(v);	// Insertion de v
			break;
	   case 2 : 	// Affichage de noeuds
			cout << "Racine = " << bt.Racine() << endl;
			cout << "Donner le num d'un noeud (ou -1 pour revenir au menu) : ";
			cin >> i;
			while (i != -1) {
			   bt.LireBloc(buf, i);
			   cout << "Bloc : " << i << endl;
			   buf.Affich();
			   cout << "\nDonner le num d'un noeud (ou -1 pour revenir au menu) : ";
			   cin >> i;
			}
			break;
	   case 3 :	// Parcours inordre du B-Arbre bt
			cout << "\nInordre : ";
	   		bt.Inordre(bt.Racine());	
			cout << endl;
			break;
	   case 4 :	// Suppression d'une valeur dans bt
			cout << "Donner une valeur a supprimer : ";
			cin >> v;
			bt.Sup(v);	// Suppression de v
			break;
	   case 5 :	// Affichage des caracteristiques du B-Arbre
			cout << "\nCaracteristiques du B-Arbre : \n";
			bt.affich_entete();
			cout << endl;
			break;
	   case 0 : 	stop = 1; // Sortir de la boucle do..while()
  	}
   }
   while (!stop);
   
  // le destructeur bt.~BTree() est execute a la fin du prgm
  // quand la var bt sera detruite.   
   return 0; 
   
}
